commit:     ff3855a7e1d6123dd553974ec27174f843d403af
Author:     Florian Schmaus <flow <AT> gentoo <DOT> org>
AuthorDate: Mon Mar 18 15:10:12 2024 +0000
Commit:     Florian Schmaus <flow <AT> gentoo <DOT> org>
CommitDate: Mon Mar 18 15:10:27 2024 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ff3855a7

dev-util/include-what-you-use: add 0.22

Signed-off-by: Florian Schmaus <flow <AT> gentoo.org>

 dev-util/include-what-you-use/Manifest             |  1 +
 .../include-what-you-use-0.22.ebuild               | 84 ++++++++++++++++++++++
 2 files changed, 85 insertions(+)

diff --git a/dev-util/include-what-you-use/Manifest 
b/dev-util/include-what-you-use/Manifest
index 5004193642a7..4e8b1cad4f3e 100644
--- a/dev-util/include-what-you-use/Manifest
+++ b/dev-util/include-what-you-use/Manifest
@@ -1,3 +1,4 @@
 DIST include-what-you-use-0.19-test-util-support-EXTRA_IWYU_ARGS.patch 2314 
BLAKE2B 
d6c99aa59b52207ece610f8a8fe52ae967f3e027118c97f665b0a5d21782d85d94658ece1e0ae0e2d86cdcb94a345f072fdbda495caf589b045a8be38bf56f99
 SHA512 
2ecd6afc2de5ff85c8a6609b151d7d1e50a985e5c52db9b298ce21bad94a3bafb7b939fcd3b3cec0b753e83ba9ea256f628fbda16837ee6b3c3f1d2ec664d4d9
 DIST include-what-you-use-0.20.tar.gz 766208 BLAKE2B 
54ae7ab18afc592bae201e551377a22d9439cb38418197836aef9d7a74d84ec7cca81ae155358504af9520a07d513e78e61ed7bcf55028f3b56aaa6e949f950b
 SHA512 
77195dc36338a37d3397c78701d81e52fc1c6a3441979fa016f154b0fc860598959e6430e78a51bbf9049f6b2bb62956e50f5531ac5c94c6554e2383ace540f5
 DIST include-what-you-use-0.21.tar.gz 776263 BLAKE2B 
32e1afc3400641ba4d648cfed0228db5b12357e5aaf4a4c5d8f063e82f14db4c6c568eedbfbfdfed033ae36d787db42122a026df8f74a080901247264ae856e2
 SHA512 
d6940fcde5f8212b7d6e1b3b8c9075157f831320279f5b7e57346c292c5b2cc52b53491a2c65b69dfcbd83ae2246c7c71555416e1faad9fd9a0aff9c12ddf1ba
+DIST include-what-you-use-0.22.tar.gz 796681 BLAKE2B 
6ae0b2fd94367c458f2db268493af8922f9e82e0a389765fc94d3d53482b7f276f7a7959f6a8d9fe6ca55e58c0db77ee50f58ce4ad375c0ea73b9029e26ea54d
 SHA512 
e95dc64372ed791441b0b92e113cbeee8aa76e8912776f776ffeb02d96f84fec18988527f46b1fbf7e174e11af043b4387ff47d9012cdd74ce38ec0bfc7ebad2

diff --git a/dev-util/include-what-you-use/include-what-you-use-0.22.ebuild 
b/dev-util/include-what-you-use/include-what-you-use-0.22.ebuild
new file mode 100644
index 000000000000..88d55bd823a9
--- /dev/null
+++ b/dev-util/include-what-you-use/include-what-you-use-0.22.ebuild
@@ -0,0 +1,84 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{10..12} )
+
+inherit cmake llvm python-single-r1
+
+DESCRIPTION="Find unused include directives in C/C++ programs"
+HOMEPAGE="https://include-what-you-use.org/";
+SRC_URI="
+       https://github.com/${PN}/${PN}/archive/${PV}.tar.gz -> ${P}.tar.gz
+"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~amd64 ~arm64 ~x86"
+
+LLVM_MAX_SLOT=18
+
+RDEPEND="
+       sys-devel/clang:${LLVM_MAX_SLOT}
+       sys-devel/llvm:${LLVM_MAX_SLOT}
+       ${PYTHON_DEPS}
+"
+DEPEND="${RDEPEND}"
+
+REQUIRED_USE="${PYTHON_REQUIRED_USE}"
+
+llvm_check_deps() {
+       has_version "sys-devel/clang:${LLVM_SLOT}"
+}
+
+pkg_setup() {
+       llvm_pkg_setup
+       python-single-r1_pkg_setup
+}
+
+src_prepare() {
+       cmake_src_prepare
+       python_fix_shebang .
+}
+
+src_configure() {
+       local mycmakeargs=(
+               # Note [llvm install path]
+               # Unfortunately all binaries using clang driver
+               # have to reside at the same path depth as
+               # 'clang' binary itself. See bug #625972
+               # Thus as a hack we install it to the same directory
+               # as llvm/clang itself.
+               -DCMAKE_INSTALL_PREFIX="$(get_llvm_prefix "${LLVM_MAX_SLOT}")"
+       )
+       cmake_src_configure
+}
+
+src_test() {
+       local clang_version=$(best_version sys-devel/clang:${LLVM_MAX_SLOT})
+       clang_version=${clang_version#*/*-} # reduce it to ${PV}-${PR}
+       clang_version=${clang_version%%[_-]*} # main version without 
beta/pre/patch/revision
+
+       local clang_include_dir_candidates=(
+               "${ESYSROOT}/usr/lib/clang/${clang_version}/include"
+               "${ESYSROOT}/usr/lib/clang/${LLVM_MAX_SLOT}/include"
+       )
+
+       local candidate_dir
+       for candidate_dir in "${clang_include_dir_candidates[@]}"; do
+               if [[ -d "${candidate_dir}" ]]; then
+                       local clang_include_dir="${candidate_dir}"
+                       break
+               fi
+       done
+
+       if [[ ! -v clang_include_dir ]]; then
+               die "Could not infer clang include directory. Candidates: 
${clang_include_dir_candidates[*]}"
+       fi
+
+       local -x IWYU_EXTRA_ARGS="-I ${clang_include_dir}"
+       "${EPYTHON}" run_iwyu_tests.py \
+                                -- "${BUILD_DIR}"/bin/${PN} \
+               || die "Tests failed with $? (using ${EPYTHON})"
+}

Reply via email to